//BJHADIRO JOB (36144,I6),'B JACKSON BIN J',TIME=(10)
//* /*ROUTE XEQ STANDBY
//* THE FOLLOWING FLAT FILES ARE CREATED TO BE USED
//* AS INPUT TO A SAS PROGRAM
// EXEC POOLSCR
BJH.TEMIND2A
BJH.TEMPAT2A
BJH.WATRSH2A
BJH.TEMWAT2A
/*
BJH.TEMPIND
BJH.TEMPPAT
BJH.WATERSH
BJH.TEMPWAT
/*
// EXEC FORTVCLG,REGION=2048K
//FORT.SYSIN DD *
C   INPUT DATA
C
C  MEN.X10.BJ.LAKES    (LAKPATW1)
C
C  TO RUN PROGRAM,  PICK A SCENARIO OF PINIT, LPAT, NPSIZE, PPATCH
C    BY COMMENTING OUT THE OTHER SCENARIOS
C
C    MAPPK IS MAP DATA
C    NEWMAP IS MAP DATA WITH DIFFERENT KINDS OF FOREST STORED
C    ILAND IS TEMPORARY COPY OF MAPPK
C
      INTEGER*2 MAPPK(650,300)
      INTEGER*2 NEWMAP(650,300)
      INTEGER*2 ILAND(650,300)
C  IROWW AND JCOLW ARE SUBSCRIPT VALUES FOR WATERSHED DATA
C   CWATER IS WATERSHED ID; WSIZE IS NUMBER OF PIXELS IN EACH
C   WATERSHED
      INTEGER IROWW(6000),JCOLW(6000)
      INTEGER IWATER(6000),KWATER(6000)
      DIMENSION WSIZE(100)
      DIMENSION P41W(100),P42W(100),POTHW(100)
      CHARACTER*20 SITE/'ADIRONDACKS'/
C     CVAL IS ARRAY OF WATERSHED ID'S
      CHARACTER*7 CVAL(67)/
     1'020075 ','020214 ','020227B','020229 ',
     1'020232 ','020234 ','020236 ','020238 ','020241 ',
     1'020242 ','020247 ','020251 ','020254 ','020258 ','020264 ',
     1'020265 ','020268 ','020272 ','020277 ','020286 ',
     1'020301 ','020306 ','020309A','020314 ','020322 ','020326 ',
     1'020339 ','020343 ','020346 ','050378 ','050383 ','050385 ',
     1'050386 ','050388 ','050392 ','050395 ','050397 ','050398 ',
     1'050402 ','050403 ','050404 ','050405 ','050406 ','050455 ',
     1'050457 ','050460A','050472 ','050476 ','050486 ','050487 ',
     1'050488 ','050490 ','050491 ','050493 ','050494A','050495 ',
     1'050496 ','050499 ','050501 ','050504 ','050506 ','050507 ',
     1'050557 ','050559 ','050566 ','050707 ','050708A'/
C
C  SCENARIO 1  BASE CASE,AMBIENT O3,  (.024PPM) P=.03
C    PROBABILITY OF BEING EPICENTER (PINIT) IS .015
C  TAKE COMMENTS OFF NEXT STATEMENTS TO TURN ON SCENARIO 1
C     LOW OZONE SCENARIO
C    PPATCH IS CUMULATIVE PROBABILITY OF PATCH SIZE
C
C     REAL PINIT/ .015/
C     INTEGER LPAT/9/, NPSIZE(9 )/1,2,3,4,5,6,7,8,9/
C     REAL PPATCH(9 )/.76,.80,.82,.85,.90,.94,.97,.99,1./
C
C  SCENARIO 2  INCREASED OZONE  (.9PPM)   P=.12
C    PROBABILITY OF BEING EPICENTER (PINIT) IS .04
C  TAKE COMMENTS OFF NEXT STATEMENTS TO TURN ON SCENARIO 2
C   HIGH OZONE SCENARIO
C   PPATCH IS CUMULATIVE PROBABILITY OF PATCH SIZE
C
      REAL PINIT/ .04/
      INTEGER LPAT/15/, NPSIZE(15)/1,2,3,4,5,6,7,8,9,10,11,12,13,
     1                             14,15/
      REAL PPATCH(15)/.62,.70,.74,.76,.775,.795,.82,.86,.915,
     1                .95,.97,.98,.99,.995,1./
C
C    SUMI,SUMIK,PIJK,SUMK  ARE ARRAYS USED IN CALCULATING
C         INDICES D1 AND D3
C     F IS ARRAY OF HARALICK INDICES
      REAL*8 PK(10), SUMI(10),SUMIK(10,10),PIJK(10,10,10),H1,D1,H3,D3
      REAL*8 SUMK(10)
      REAL*8 F(16)
      DIMENSION ICENT(4000),JCENT(4000)
C ICENT AND JCENT ARE EPICENTER ROW AND COL LOCATIONS
      DIMENSION IPATFR(25),PATPER(25)
C IPATFR AND PATPER ARE HISTOGRAM ARRAYS FOR PATCH SIZES
      DIMENSION NUMFOR(3),PERFOR(3)
C  NUMFOR AND PERFOR ARE NUMBER AND PERCENT OF FOREST TYPES
C     1- DECIDUOUS  2- CONIFEROUS  3 -MIXED
C
C -------------------------------------------------------------------
C THE VALUES FROM THE DATA FILE ARE READ INTO MATRIX MAPPK
C -------------------------------------------------------------------
C
C     ISEED IS RANDOM NUMBER SEED FOR PIKING EPICENTERS
      COMMON/SEED/ISEED
      ISEED = 234567
      NROW = 0
      NCOL = 0
      ISIZE= 0
      JSIZE= 0
C
C
C     THIS SECTION OF THE CODE READS IN THE LANDUSE ARRAY FROM
C     TWO DIFFERENT SCENES (GLEN FALLS AND LAKE CHAMPLAIN
C     FROM USGS 1983) AND PASTES THEM TOGETHER.  THIS SCENE COVERS
C     THE ADIRONDACKS AREA
C     EACH PIXEL IS 4 HECTARES
C
C          4848000 < UTM_NV < 4927000
C          580400 < UTM_EV < 619400
C          43.6 DEG < LATITUDE < 44.7 DEG
C          73.3 DEG < LONGITUDE < 74 DEG
C
      DO 303 J = 1,300
      DO 303 I = 1,650
C     MAP10(I,J) = 0
  303 MAPPK(I,J) = 0
 301  READ (20,*,END=302) INV,JEV, M
C     IF( I .LT. 50 .AND. J .GT. 600)WRITE (6,309) I,J,MAPT(I,J)
 309  FORMAT(6I10)
C
      IF (INV .GE. 4848200 .AND. INV .LE. 4927000
     1   .AND. JEV .GE. 580400 .AND. JEV .LE. 619400) THEN
         I = (INV -4848200.)/200.+1.5
         J=  (JEV -580400. )/200.+1.
C  GLENS FALLS UTM NUMBER END WITH 100, LAKE CHAMPLAIN UTMS
C  END WITH 200.  THE .5 ADDED TO THE I AND J SUBSCRIPT SCOOT
C  GLENS FALL OVER TO MATCH UP WITH LAKE CHAMPLAIN
      IF (I .LE. 650 .AND. I .GT. 0 .AND. J .LE. 300
     1    .AND. J .GT. 0) THEN
         MAPPK(I,J) = M
         ISIZE = MAX(ISIZE,I)
         JSIZE = MAX(JSIZE,J)
         ELSE
           WRITE (6,309) I,J,INV,JEV,M
         ENDIF
      ENDIF
      GO TO 301
 302  CONTINUE
C
C  SET ISIZE AND JSIZE TO 100 TO RUN A SMALL CASE
C     FOR TESTING PURPOSES
C
C     ISIZE = 100
C     JSIZE = 100
       WRITE (6,340)ISIZE,JSIZE
  340 FORMAT ('0FINISHED READING FILE ISIZE,JSIZE=',2I6)
  360 CONTINUE
      DO 400 I=1,ISIZE
      DO 400 J=1,JSIZE
        IF (MAPPK(I,J) .EQ. 0 .AND. MAPPK(I-1,J) .NE. 0
     1      .AND. MAPPK(I+1,J) .NE. 0) MAPPK(I,J) = MAPPK(I+1,J)
C
C  THERE ARE A FEW HOLES WHERE THE TWO SCENES COME TOGETHER,
C     SO FILL THEM IN
C
C    THIS ENDS THE SECTION OF THE CODE FOR READING IN LANDUSE DATA
C
C
  400 CONTINUE
C     WRITE (40,410) (MAPPK(I,J),J=1,JSIZE)
  410 FORMAT (100I2)
      WRITE (6,470)
  470 FORMAT ('0 MOST SIGNIFICANT DIGIT OF LANDUSE VALUE'/
     1 '   NORTH TO SOUTH DOWN THE PAGE, THEN NEXT PAGE IS TO EAST'/
     3 '   4848000 < UTM_NV < 4927000'/
     4 '   580400 < UTM_EV < 619400'/)
C    5 '   43.6 DEG < LATITUDE < 44.7 DEG'/
C    6 '   73.3 DEG < LONGITUDE < 74 DEG'/)
C
C   CALL ROUTINE TO READ IN WATERSHED DATA
C     THERE ARE 66 WATERSHEDS IDENTIFIED BY CODES
C     THIS DATA COVERS THE SAME AREA AS THE LANDUSE DATA
C
      CALL RWATER(IROWW,JCOLW,IWATER,KWATER,NWATER,WSIZE,CVAL,
     1 MAPPK,650)
C     WRITE (6,476) (I,CVAL(I),I=1,67)
  476 FORMAT (I5,2X,A7)
C
C  STORE ORIGINAL MATRIX IN ILAND BECAUSE IT WILL BE NEEDED LATER
C
      DO 475 I=1,ISIZE
      DO 475 J=1,JSIZE
  475 ILAND(I,J) = MAPPK(I,J)
      WRITE (6,531)
  531 FORMAT('1 THE NEXT PRINTOUT IDENTIFIES'/
     1 ' URBAN      (TYPES 11-17   ) AS 1'/
     1 ' AGRICULTURE(TYPES 21-24   ) AS 2'/
     1 ' RANGELAND (TYPES 31,32,33) AS 3'/
     2 ' FOREST     (TYPE 41-43)    AS 4'/
     5 ' WATER     (TYPES 51-54   ) AS 5'/
     6 ' WETLANDS  (TYPES 61-62   ) AS 6'/
     7 ' BARREN    (TYPES 71-77   ) AS 7')
      CALL WRITE10(MAPPK,100   ,100 ,650)
C
C   NEWMAP HAS MAP DATA RECODED TO INCLUDE DIFFERENT KINDS OF
C        FOREST
C
      CALL GETNEW(MAPPK,NEWMAP,ISIZE,JSIZE,650)
      WRITE (6,530)
  530 FORMAT('1 THE NEXT PRINTOUT IDENTIFIES'/
     1 ' URBAN      (TYPES 11-17   ) AS 1'/
     1 ' AGRICULTURE(TYPES 21-24   ) AS 2'/
     1 ' RANGELAND (TYPES 31,32,33)  AS 3'/
     2 ' DECIDUIOUS (TYPE 41)        AS 4'/
     3 ' CONIFERS (TYPE 42)          AS 5'/
     4 ' AND MIXED (TYPE 43)         AS 6'/
     5 ' WATER     (TYPES 51-54   )  AS 7'/
     6 ' WETLANDS  (TYPES 61-62   )  AS 8'/
     7 ' BARREN    (TYPES 71-77   )  AS 9')
      CALL WRITEM(NEWMAP,100   ,100 ,650)
C  FORTYP FINDS PERCENT OF DIFFERENT KINDS OF FOREST
      CALL FORTYP(MAPPK,ISIZE,JSIZE,NUMFOR,PERFOR,TOTFOR,0)
C    CALCP FINDS SUMS FOR CALCULATING INDICES D1 AND D3
C    COMINANCE AND CONTAGION
      CALL CALCP(NEWMAP,ISIZE,JSIZE,PK,SUMK,PIJK,SUMI,SUMIK ,0,650,
     1 NUMUSE,NUMPIX,H1,D1,H3,D3)
C   FOREDG FINDS EDGE COUNTS OF DIFFERENT KINDS OF FOREST WITH
C      NONFOREST
      CALL FOREDG(MAPPK,ISIZE,JSIZE,DECEDG,CONEDG,XEDG,
     1 DECEDA,CONEDA,XEDA,DECEDW,CONEDW,XEDW,0)
C    FORINT FINDS THE NUMBER OF INTERIOR FOREST PIXELS FOR THE
C     WHOLE LANDUSE MATRIX
      CALL FORINT(MAPPK,ISIZE,JSIZE,NINTER,0)
C  HARA CALCULATES HARALICK STATISTICS
      CALL HARA(SITE,SUMIK,0,F)
C   WSHED CALCULATES SOME PERCENTAGES OF LANDUSE FOR EACH
C    WATERSHED
      CALL WSHED(MAPPK,ISIZE,JSIZE,650,
     1   IROWW,JCOLW,KWATER,NWATER,WSIZE,P41W,P42W,POTHW,IW)
      NUMPAT = 0
      NCHPIX = 0
      ITER   = 0
C
C   NOW WRITE OUT ENDPOINTS TO FLAT FILES SO THAT THE SAS PROGRAM
C    CAN READ THEM IN AND MAKE SAS DATASETS
C
        WRITE(10,2010) SITE,ITER,NUMUSE,NUMPIX,NUMPAT,NCHPIX,NINTER,
     1  H1,D1,H3,D3,(F(I),I=1,16)
     1 ,DECEDG,CONEDG,XEDG
     1 ,DECEDA,CONEDA,XEDA
     1 ,DECEDW,CONEDW,XEDW
     2 ,(PK(I),I=1,9), PINIT
      DO 660 I=1,67
      WRITE (50,570) PINIT,ITER, CVAL(I),P41W(I),P42W(I),POTHW(I)
  660 CONTINUE
C
C  ITERATIONS OF INFESTATION OF MATRIX
C
C     DO 1000 ITER = 1,1
      DO 1000 ITER = 1,100
C
C  LET SUBROUTINES WRITE OUTPUT FOR FIRST  ITERATION
C

      IF (ITER .GT. 1) THEN
        IW = 1
         ELSE
         IW =0
         ENDIF
C  RESTORE ORIGINAL LANDUSE MATRIX TO MAPPK
      DO 525 I=1,ISIZE
      DO 525 J=1,JSIZE
  525 MAPPK(I,J) = ILAND(I,J)
C   EPICEN RANDOMLY PUTS EPICENTERS OF INFESTATION ON MAPPK
      CALL EPICEN(MAPPK,ISIZE,JSIZE,PINIT,ICENT,JCENT,NCENT,IW)
C    GROW LETS THE INFESTED PATCHES GROW ACCORDING TO PLAN
      CALL GROW (MAPPK,ISIZE,JSIZE,ICENT,JCENT,NCENT,
     1  LPAT,NPSIZE,PPATCH,NUMPAT,NCHPIX,IPATFR,PATPER,IW)
C     CALL DIV10(MAPPK,MAP10,ISIZE,JSIZE,650)
      WRITE (6,520)ITER
  520 FORMAT('0PATCHES HAVE BEEN PLACED ON THE MAP FOR ITERATION',I5)
C    RECODE THE MAPPK TO NEWMAP WHICH HAS ALL FOREST TYPES
      CALL GETNEW(MAPPK,NEWMAP,ISIZE,JSIZE,650)
      IF (IW .EQ. 0) THEN
         WRITE (6,530)
         CALL WRITEM(NEWMAP,100  ,100  ,650)
         ENDIF
C   DO ALL CALCULATIONS ON THE LANDUSE MATRIX THAT HAS
C    BEEN INFESTED
      CALL FORTYP(MAPPK,ISIZE,JSIZE,NUMFOR,PERFOR,TOTFOR,IW)
      CALL CALCP(NEWMAP,ISIZE,JSIZE,PK,SUMK,PIJK,SUMI,SUMIK,IW,650,
     1 NUMUSE,NUMPIX,H1,D1,H3,D3)
      CALL FOREDG(MAPPK,ISIZE,JSIZE,DECEDG,CONEDG,XEDG,
     1 DECEDA,CONEDA,XEDA,DECEDW,CONEDW,XEDW,IW)
      CALL FORINT(MAPPK,ISIZE,JSIZE,NINTER,IW)
      CALL HARA(SITE,SUMIK, 1,F)
      CALL WSHED(MAPPK,ISIZE,JSIZE,650,
     1   IROWW,JCOLW,KWATER,NWATER,WSIZE,P41W,P42W,POTHW,IW)
C
C  WRITE OUT ENDPOINTS TO FLAT FILE FOR INPUT TO SAS PROGRAM
C   FOR THIS ITERATION
C
        WRITE(10,2010) SITE,ITER,NUMUSE,NUMPIX,NUMPAT,NCHPIX,NINTER,
     1  H1,D1,H3,D3,(F(I),I=1,16)
     1 ,DECEDG,CONEDG,XEDG
     1 ,DECEDA,CONEDA,XEDA
     1 ,DECEDW,CONEDW,XEDW
     2 ,(PK(I),I=1,9), PINIT
C
C  WRITE OUT FREQUENCIES OF PATCH SIZES FOR EACH ITERATION
C     TO SAS PROGRAM
C
      DO 550 I=1,25
      IF (IPATFR(I) .NE. 0) WRITE (30,2011) PINIT,ITER,I,IPATFR(I)
 2011 FORMAT (F10.5,3I5)
  550 CONTINUE
 2010   FORMAT (A20,6I8,/(10G15.7))
C
C WRITE OUT WATERSHED STATISTICS TO SAS PROGRAM
C     FOR THIS ITERATION
      DO 560 I=1,67
      WRITE (50,570) PINIT, ITER, CVAL(I),P41W(I),P42W(I),POTHW(I)
  570 FORMAT (F10.5, I5, 2X, A7, 3G16.8)
  560 CONTINUE
C
 1000 CONTINUE
C
C   END OF ITERATIONS
C
      RETURN
      END
      SUBROUTINE RWATER(IROWW,JCOLW,IWATER,KWATER,NWATER,WSIZE
     1 ,CVAL,MAPPK,ID1)
C
C  THIS PROGRAM READS IN THE WATERSHED CODES FOR OVERLAYING
C    ON THE LANDUSE DATA FOR ADIRONDACKS
C
C  NORTH EDGE OF ROW 1 IN INPUT FILE CORRES TO UTM_NV 4927000
C  NORTH EDGE OF ROW 394 CORRES TO UTM_NV 4848000
C  WEST EDGE OF COL 1 IN INPUT FILE CORRES TO UTM_EV 580400
C  WEST EDGE OF COL 195 IN INPUT FILE CORRES TO UTM_EV 619200
C
C   SO SUBSCRIPTS HAVE TO BE RECALCULATED TO FIT ON
C      LANDSCAPE DATA
      INTEGER IROWW(1),JCOLW(1),KWATER(1)
      INTEGER IWATER(1)
      INTEGER*2 MAPPK(ID1,1)
      DIMENSION WSIZE(1)
      CHARACTER*7 CVAL(1)
      NWATER = 0
      DO  5 I=1,100
    5 WSIZE(I) = 0
   10 CONTINUE
      READ (40,*,END=50) I,J,IC
      NWATER = NWATER + 1
      INV = 4927000 - (I-1) * 200
      JEV = 580400 + (J-1) * 200
      NEWI = (INV -4848200.)/200.+1
      NEWJ=  (JEV -580400. )/200.+1.
      IF ( NEWI .GT. 0 .AND. NEWI .LE. 6000 .AND.
     1     NEWJ .GT. 0 .AND. NEWJ .LE. 6000 ) THEN
        IROWW(NWATER) = NEWI
        JCOLW(NWATER) = NEWJ
        CALL XWATER(IC,K)
        KWATER(NWATER) = K
        WSIZE(K) = WSIZE(K) + 1
        IWATER(NWATER) = IC
        WRITE (70,200) INV,JEV,CVAL(K),MAPPK(NEWI,NEWJ)
  200   FORMAT (2I10,2X,A7,2X,I10)
        ENDIF
      GO TO 10
   50 CONTINUE
      WRITE (6,60) NWATER,
     1             (IROWW(I),JCOLW(I),KWATER(I),IWATER(I),I=1,100)
   60 FORMAT ('0NUMBER OF WATERSHED VALUES=',I8/(' ',4I8))
      DO 80 I = 1,100
       IF (WSIZE(I) .NE. 0) WRITE (6,90) I,WSIZE(I)
   90 FORMAT (I5,F8.1)
   80 CONTINUE
      RETURN
      END
      SUBROUTINE XWATER(IWATER,K)
      INTEGER     IVAL(67)/
     1 20075 , 20214 , 20227 , 20229 ,
     1 20232 , 20234 , 20236 , 20238 , 20241 ,
     1 20242 , 20247 , 20251 , 20254 , 20258 , 20264 ,
     1 20265 , 20268 , 20272 , 20277 , 20286 ,
     1 20301 , 20306 , 20309 , 20314 , 20322 , 20326 ,
     1 20339 , 20343 , 20346 , 50378 , 50383 , 50385 ,
     1 50386 , 50388 , 50392 , 50395 , 50397 , 50398 ,
     1 50402 , 50403 , 50404 , 50405 , 50406 , 50455 ,
     1 50457 , 50460 , 50472 , 50476 , 50486 , 50487 ,
     1 50488 , 50490 , 50491 , 50493 , 50494 , 50495 ,
     1 50496 , 50499 , 50501 , 50504 , 50506 , 50507 ,
     1 50557 , 50559 , 50566 , 50707 , 50708/
C
C  THIS PROGRAM RETURNS THE INDEX OF A WATERSHED
C   ACCORDING TO THE WATERSHED CODE
C
      DO 100 I = 1,67
        K = I
      IF (IWATER .EQ. IVAL(I) ) GO TO 200
  100 CONTINUE
  200 CONTINUE
      RETURN
      END
      SUBROUTINE WSHED(MAPPK,ISIZE,JSIZE,ID1,
     1   IROWW,JCOLW,KWATER,NWATER,WSIZE,P41W,P42W,POTHW,IW)
      DIMENSION IROWW(1),JCOLW(1),KWATER(1),WSIZE(1)
      DIMENSION P41W(1),P42W(1),POTHW(1)
      DIMENSION PK(10,68)
      INTEGER*2 MAPPK(ID1,1)
C
C  THIS PROGRAM CALCULATES THE FOLLOWING:
C P41W IS PERCENT OF DECIDUOUS/LAND IN EACH WATERSHED
C P42W IS PERCENT OF CONIFER/LAND
C POTHW IS PCT OF(URBAN + AGR + RANGELAND + WETLAND + BARREN)/LAND
C
      DO 5 I=1,67
      P41W(I) = 0.
      P42W(I) = 0.
      POTHW(I) = 0.
    5 CONTINUE
      DO 6 I=1,7
      DO 6 J=1,67
    6 PK(I,J) = 0.
      DO 10 I=1,NWATER
      I1 = MAPPK(IROWW(I),JCOLW(I))/10
      K = KWATER(I)
      IF(I1 .EQ. 1 .OR. I1 .EQ. 2 .OR. I1 .EQ. 3
     1  .OR. I1 .EQ. 6 .OR. I1 .EQ. 7)
     1       POTHW(K) = POTHW(K) +1
      IF(MAPPK(IROWW(I),JCOLW(I)) .EQ. 41) P41W(K) = P41W(K) + 1
      IF(MAPPK(IROWW(I),JCOLW(I)) .EQ. 42) P42W(K) = P42W(K) + 1
      PK(I1,K) = PK(I1,K) + 1
  10  CONTINUE
      DO 20 I=1,67
      IF (WSIZE(I) .NE. 0.) THEN
        POTHW(I) = POTHW(I)/WSIZE(I)*100.
        P41W(I) = P41W(I)/(WSIZE(I)-PK(5,I))*100.
        P42W(I) = P42W(I)/(WSIZE(I)-PK(5,I))*100.
        DO 22 J=1,7
        PK(J,I) = PK(J,I)/WSIZE(I)*100.
   22   CONTINUE
        ENDIF
   20 CONTINUE
      IF (IW .EQ. 0 ) THEN
       WRITE(6,101)
  101  FORMAT ('0   P41W,P42W,POTHW,WSIZE,P1-P7')
       DO 30 I=1,67
   30  WRITE(6,100)I,P41W(I),P42W(I),POTHW(I),
     1             WSIZE(I),(PK(J,I),J=1,7)
  100  FORMAT (I5,4F7.3,7G12.4)
       ENDIF
      RETURN
      END
      SUBROUTINE WRITEM(MAPPK,ISIZE,JSIZE,ID1)
C
C  WRITEM WRITES OUT THE LANDUSE MATRIX IN 100 COLUMN CHUNCKS
C
      CHARACTER*1 MAPA(300)
      INTEGER*2 MAPPK(ID1,300),MAP1(300)
      JLIM = (JSIZE-1)/100+1
      DO 450 K=1,JLIM
      J1=K*100-99
      J2=K*100
      WRITE (6,460) J1,J2
  460 FORMAT( '0ROW   COLUMNS ',I5,' TO ',I5)
      DO 450 I=ISIZE,1,-1
      DO 405 J=J1,J2
  405 MAP1(J) = MAPPK(I,J)
  450 WRITE (6 ,420)I, (MAP1(J),J=J1,J2  )
  420 FORMAT (' ',I3,1X,100I1)
      RETURN
      END
      SUBROUTINE WRITE10(MAPPK,ISIZE,JSIZE,ID1)
C
C  WRITE OUT MATRIX, BUT FIRST DIVIDE VALUE BY 10
C
      CHARACTER*1 MAPA(300)
      INTEGER*2 MAPPK(ID1,300),MAP1(300)
      JLIM = (JSIZE-1)/100+1
      DO 450 K=1,JLIM
      J1=K*100-99
      J2=K*100
      WRITE (6,460) J1,J2
  460 FORMAT( '0ROW   COLUMNS ',I5,' TO ',I5)
      DO 450 I=ISIZE,1,-1
      DO 405 J=J1,J2
  405 MAP1(J) = MAPPK(I,J)/10
  450 WRITE (6 ,420)I, (MAP1(J),J=J1,J2  )
  420 FORMAT (' ',I3,1X,100I1)
      RETURN
      END
      SUBROUTINE EPICEN(MAPPK,ISIZE,JSIZE,PINIT,ICENT,JCENT,NCENT,IW)
C
C  SPRINKLE EPICENTERS ON MATRIX ACCORDING TO
C     PROBABILITY OF PINIT IF IT IS A CONIFEROUS OR MIXED HARDWOOD
C     PIXEL (LANDUSE=42 OR 43)
C
      INTEGER*2 MAPPK(650,300)
      DIMENSION ICENT(1),JCENT(1)
      COMMON/SEED/ISEED
      NCENT = 0
      DO 10 J=1,JSIZE
      DO 10 I=1,ISIZE
        IF (MAPPK(I,J) .EQ. 42 .OR. MAPPK(I,J) .EQ. 43) THEN
        X = URAND(ISEED)
        IF (X .LE. PINIT) THEN
          NCENT =NCENT+1
          ICENT(NCENT) = I
          JCENT(NCENT) = J
          ENDIF
          ENDIF
   10 CONTINUE
      IF (IW .EQ. 0)WRITE (6,530) NCENT,(I,ICENT(I),JCENT(I),I=1,100)
  530 FORMAT ('1EPICENTERS = ',I5/' N    ROW  COL'/(3I5))
      RETURN
      END
      SUBROUTINE FORTYP(MAPPK,IMAX,JMAX,NUMFOR,PERFOR,TOTFOR,IW)
C
C   FORTYP CALCULATES PERCENTAGES OF DIFFERENT KINDS OF FOREST
C   1 = DECIDUOUS
C   2 = CONIFER
C   3 = MIXED
C
      DIMENSION NUMFOR(1),PERFOR(1)
      INTEGER*2 MAPPK(650,300)
      DO 10 I=1,3
   10 NUMFOR(I) = 0
      TOTFOR = 0
      DO 20 J=1,JMAX
      DO 20 I=1,IMAX
      M1 = MAPPK(I,J) /10
      IF (M1 .EQ.4) THEN
        M2 = MAPPK(I,J)-40
        NUMFOR(M2)=NUMFOR(M2) + 1
        TOTFOR=TOTFOR + 1
        ENDIF
   20 CONTINUE
      DO 30 I=1,3
   30 PERFOR(I) = NUMFOR(I)*100./TOTFOR
      IF(IW .EQ.0) WRITE (6,40) TOTFOR
   40 FORMAT ('0TOTAL NUMBER OF FOREST PIXELS=',F8.0/
     1 ' FOREST TYPE    FREQUENCY    PERCENT')
      IF (IW .EQ. 0) WRITE  (6,50) (I,NUMFOR(I),PERFOR(I),I=1,3)
   50 FORMAT (' ',2I10,F10.4)
      RETURN
      END
      SUBROUTINE GROW(MAPPK,ISIZE,JSIZE,IC,JC,NC,
     1LPAT,NPSIZE,PPATCH,NTOTP,NTOTX,IFREQ,PERC,IW)
C
C  GROW LETS THE EPICENTERS GROW INTO INFESTED PATCHES
C    ACCORDING TO THE PROBABILITY SCHEME
C
      COMMON/SEED/ISEED
      DIMENSION IFREQ(25), PERC(25)
C  IC AND JC ARE THE SUBSCRIPTS FOR THE EPICENTERS
      DIMENSION IC(1) ,JC(1)
      INTEGER*2 MAPPK(650,300)
      DIMENSION NPSIZE(1), PPATCH(1)
C
C  ID AND JD ARE ROW AND COLUMN INDEX OFFSETS FOR FINDING
C   A COMPACT CONTIGUOUS PATCH OF FOREST AROUND THE EPICENTER
C
      INTEGER ID(81)/0,1,1,0,-1,-1,-1,0,1
     1 ,4*2,1,0,-1,5*-2,-1,0,1,2,
     2 6*3,2,1,0,-1,-2,7*-3,-2,-1,0,1,2,3,
     3 8*4,3,2,1,0,-1,-2,-3,
     4 9*-4,-3,-2,-1,0,1,2,3,4/
      INTEGER JD(81)/0,0,1,1,1,0,3*-1,
     1 -1,0,1,5*2,1,0,-1,5*-2,
     2 -2,-1,0,1,2,6*3,3,2,1,0,-1,-2,7*-3,
     3 -3,-2,-1,0,1,2,3,8*4,
     4 4,3,2,1,0,-1,-2,-3,9*-4/
C
C  INITIALIZE HISTOGRAM ARRAYS
C
      DO 25 I=1,25
      IFREQ(I) = 0
   25 PERC(I) = 0.
      NTOTP   = 0
      NTOTX   = 0
C
C  FOR EACH EPICENTER, GROW AN INFESTED PATCH
C   THE SIZE OF THE PATCH IS DETERMINED BY A
C   TABLE OF PROBABILITY AND PATCHSIZE
C
      DO 500 K=1,NC
C
C   FOR EACH EPICENTER
C
C    FIND THE SIZE OF THE PATCH
C
      X = URAND(ISEED)
      DO 30 I=1,LPAT
      NPATCH = NPSIZE(I)
      IF (X .LE. PPATCH(I)) GO TO 50
   30 CONTINUE
   50 CONTINUE
C     IF(IW .EQ. 0)WRITE (6,210) X,NPATCH
  210 FORMAT (' RANDOM NUMBER, SIZE OF PATCH =',F8.5,I5)
C
C   PATCH SIZE IS DETERMINED, NOW GROW THE PATCH
C
C
C   CENTER OF PATCH IS AUTOMATICALLY IN THE PATCH
C
      NUMPAT = 1
      LTYPE = MAPPK(IC(K),JC(K))
C
C  CHANGE CONIFER (42) TO RANGELAND (30)
C  CHANGE MIXED (43) TO DECIDIOUS (41)
C
C
C TYPE 30 IS TEMPORARY VALUE FOR RANGELAND,
C TYPE 41 IS VALUE FOR DECIDUOUS
C
      IF (LTYPE .EQ. 42) NTYPE =30
      IF(LTYPE .EQ. 43) NTYPE = 41
      MAPPK(IC(K),JC(K)) = NTYPE
C     IF(IW .EQ. 0)WRITE (6,520)
  520 FORMAT ('0COUNT, ROW, COL, NEW VALUE OF PIXEL')
C     IF (IW .EQ. 0)
C    1WRITE (6,530) NUMPAT, IC(K), JC(K), MAPPK(IC(K),JC(K))
  530 FORMAT (' ',4I6)
C
      DO 80 N=2,81
C
C  TRANSFER OUT OF THE LOOP IF ENOUGH PIXELS HAVE BEEN FOUND
C
      IF (NUMPAT .GE. NPATCH) GO TO 100
C
C   IF THE PIXEL IS INSIDE THE MATRIX
C   IF THE PIXEL IS LANDTYPE 42 OR 43
C
      I=IC(K)+ID(N)
      J=JC(K)+JD(N)
      IF (I .GT. 0 .AND. I .LE. ISIZE
     1 .AND. J .GT. 0 .AND. J .LE. JSIZE
     2  .AND. (MAPPK(I,J) .EQ. LTYPE)) THEN
C
C  IF IT IS NOT THE CENTER PIXEL, CHECK TO MAKE SURE THAT AN ADJACENT
C    PIXEL HAS ALREADY BEEN CHOSEN FOR THE PATCH
C
      ICHECK = 0
        IF(ICHECK .EQ. 0 .AND. I+1 .LE. ISIZE) THEN
          IF( MAPPK(I+1,J) .EQ. NTYPE) ICHECK=1
            ENDIF
          IF (ICHECK .EQ. 0 .AND. J+1 .LE. JSIZE)THEN
            IF( MAPPK(I,J+1) .EQ. NTYPE) ICHECK=1
            ENDIF
          IF (ICHECK .EQ. 0 .AND. I-1 .GT. 0)THEN
            IF( MAPPK(I-1,J) .EQ. NTYPE) ICHECK=1
            ENDIF
          IF (ICHECK .EQ. 0 .AND. J-1 .LE. JSIZE)THEN
            IF( MAPPK(I,J-1) .EQ. NTYPE) ICHECK=1
            ENDIF
          IF (ICHECK .EQ. 0 .AND. I+1 .GT. 0)THEN
            IF( MAPPK(I+1,J) .EQ. NTYPE) ICHECK=1
            ENDIF
          IF (ICHECK .EQ. 1) THEN
            MAPPK(I,J) = NTYPE
            NUMPAT = NUMPAT+1
C           IF (IW .EQ. 0)WRITE (6,530) NUMPAT,I,J,MAPPK(I,J)
            ENDIF
        ENDIF
   80 CONTINUE
  100 CONTINUE
C
C  PATCH HAS BEEN FOUND OR FOREST HAS RUN OUT
C
      IFREQ(NUMPAT)=IFREQ(NUMPAT) + 1
      NTOTX = NTOTX + NUMPAT
  500 CONTINUE
C
C  CALCULATE HISTOGRAM OF ACTUAL PATCH SIZES
C
      DO 110 I=1,25
  110 NTOTP =NTOTP  + IFREQ(I)
      IF (IW .EQ. 0) WRITE (6,125) NTOTX,NTOTP
  125 FORMAT ('0TOTAL NUMBER OF CHANGED PIXELS=',I15/
     1        ' TOTAL NUMBER OF PATCHES       =',I15/
     2  ' HISTOGRAM OF PATCH SIZES'/
     3 ' PATCH SIZE   FREQUENCY   PERCENT')
      DO 120 I=1,25
      PERC(I) = IFREQ(I)*100./NTOTP
  120 IF(IW .EQ. 0 .AND. IFREQ(I) .NE. 0)
     1 WRITE (6,130) I,IFREQ(I),PERC(I)
  130 FORMAT (' ',I8,I10,F12.3)
      RETURN
      END
      SUBROUTINE FOREDG(MAPPK,ISIZE,JSIZE
     1 ,DECEDG,CONEDG,XEDG,
     2 DECEDA,CONEDA,XEDA,DECEDW,CONEDW,XEDW,IW)
C
C   FOREDG CALCULATES THE EDGE COUNT OF FOREST TO NONFOREST
C   NEDGE IS THE NUMBER OF POINTS WHERE A FOREST TYPE ABUTS
C     A NON-FOREST TYPE.  THE FIRST DIMENSION IS THE TYPE OF
C     FOREST 1= DECIDUOUS, 2= CONIFEROUS, 3=MIXED.  THE SECOND
C     DIMENSION IS THE LANDUSE TYPE, LEVEL 1
C
      INTEGER*2 MAPPK(650,300)
      DIMENSION NEDGE(3,10)
      DO 40 I=1,3
      DO 40 J = 1,10
   40 NEDGE(I,J) = 0
      DO 50 J=1,JSIZE-1
      DO 50 I=1,ISIZE-1
        I1 = MAPPK(I,J)/10
        IF (I1 .EQ. 4) THEN
          I2 = MAPPK(I,J)-I1*10
          IP1 = MAPPK(I+1,J)/10
          JP1 = MAPPK(I,J+1)/10
          IF(IP1 .NE. 4 .AND. IP1 .NE. 0)
     1      NEDGE(I2,IP1)=NEDGE(I2,IP1)+1
          IF(JP1 .NE. 4 .AND. JP1 .NE. 0)
     1      NEDGE(I2,JP1)=NEDGE(I2,JP1)+1
       ENDIF
   50 CONTINUE
      IF (IW .EQ. 0)WRITE (6,60)
   60 FORMAT ('0FOREST EDGE COUNT '/
     1 ' FOREST TYPE   NON-FOREST TYPE   COUNT')
      DO 70 J=1,9
      DO 70 I=1,3
   70 IF(IW .EQ. 0 .AND. NEDGE(I,J) .NE. 0)WRITE(6,80)I,J,NEDGE(I,J)
   80 FORMAT (' ',3I12)
C
C CALC DIFFERENT FOREST EDGES WITH URBAN,AGR,WETLAND,OR BARREN
C  RETURN FOREST TYPE EDGES ON AGR AND WETLAND
C
      DECEDG=NEDGE(1,1)+NEDGE(1,2)+NEDGE(1,3)+NEDGE(1,6)+NEDGE(1,7)
      CONEDG=NEDGE(2,1)+NEDGE(2,2)+NEDGE(2,3)+NEDGE(2,6)+NEDGE(2,7)
      XEDG=NEDGE(3,1)+NEDGE(3,2)+NEDGE(3,3)+NEDGE(3,6)+NEDGE(3,7)
      DECEDA = NEDGE(1,2)
      CONEDA = NEDGE(2,2)
      XEDA = NEDGE(3,2)
      DECEDW = NEDGE(1,6)
      CONEDW = NEDGE(2,6)
      XEDW = NEDGE(3,6)
      IF (IW .EQ. 0)WRITE (6,90) DECEDG,CONEDG,XEDG
   90 FORMAT ('0TOTAL EDGE OF URBAN,AGRICULTURE,RANGELAND,WETLAND',
     1 ' AND BARREN WITH '/' DECIDUOUS',F10.0/' CONIFER ',F10.0/
     2 ' MIXED   ',F10.0)
      RETURN
      END
      SUBROUTINE FORINT(MAPPK,ISIZE,JSIZE,NINTER,IW)
      INTEGER*2 MAPPK(650,300)
C
C  COUNT THE NUMBER OF INTERIOR FOREST POINTS
C     FOR THE WHOLE SCENE
C
      NINTER = 0
      DO 50 J=2,JSIZE-1
      DO 50 I=2,ISIZE-1
      IF (MAPPK(I,J)/10 .EQ. 4) THEN
        IF (MAPPK(I+1,J)/10 .EQ. 4
     1 .AND. MAPPK(I+1,J+1)/10 .EQ. 4
     2 .AND. MAPPK(I,J+1  )/10 .EQ. 4
     3 .AND. MAPPK(I-1,J+1)/10 .EQ. 4
     4 .AND. MAPPK(I-1,J  )/10 .EQ. 4
     5 .AND. MAPPK(I-1,J-1)/10 .EQ. 4
     6 .AND. MAPPK(I,J-1  )/10 .EQ. 4
     7 .AND. MAPPK(I+1,J-1)/10 .EQ. 4) NINTER = NINTER + 1
      ENDIF
   50 CONTINUE
      IF (IW .EQ.0) WRITE (6,60) NINTER
   60 FORMAT ('0NUMBER OF INTERIOR FOREST POINTS =',I10)
      RETURN
      END
      SUBROUTINE GETNEW(MAPPK,NEWMAP,ISIZE,JSIZE,ID1)
C
C   GETNEW RECODES THE LANDUSE MATRIX TO INCLUDE DIFFERENT KINDS
C   OF FOREST
C
      INTEGER*2 MAPPK(ID1,1)
      INTEGER*2 NEWMAP(ID1,1)
      DO 10 I = 1,ISIZE
      DO 10 J = 1,JSIZE
      IF (MAPPK(I,J)/10 .EQ. 1) THEN
         NEWMAP(I,J) = 1
      ELSE IF (MAPPK(I,J)/10 .EQ. 2) THEN
         NEWMAP(I,J) = 2
      ELSE IF (MAPPK(I,J)/10 .EQ. 3) THEN
         NEWMAP(I,J) = 3
      ELSE IF (MAPPK(I,J) .EQ. 41)THEN
         NEWMAP(I,J) = 4
      ELSE IF (MAPPK(I,J) .EQ. 42)THEN
         NEWMAP(I,J) = 5
      ELSE IF (MAPPK(I,J) .EQ. 43)THEN
         NEWMAP(I,J) = 6
      ELSE IF (MAPPK(I,J)/10 .EQ. 5) THEN
         NEWMAP(I,J) = 7
      ELSE IF (MAPPK(I,J)/10 .EQ. 6) THEN
         NEWMAP(I,J) = 8
      ELSE IF (MAPPK(I,J)/10 .EQ. 7) THEN
         NEWMAP(I,J) = 9
         ENDIF
   10 CONTINUE
      RETURN
      END
      SUBROUTINE CALCP(LAND,IMAX,JMAX,PK,SUMK,PIJK,SUMI,SUMIK,IW,ID1,
     1 NUM,NUMPIX,H1,D1,H3,D3)
C
C   CALCP CALCULATES THE SUMS FOR THE INDICES D1 AND D3
C     (DOMINANCE AND CONTAGION)
C
C  LAND IS INTEGER*2 2 DIMENSIONAL MATRIX OF LANDUSE OBSERVARIONS
C      RANGE OF VALUES FROM 1 TO 10   (0 IS MISSING DATA)
C  IMAX IS NUMBER OF ROWS OF LAND
C  JMAX IS NUMBER OF COLS OF LAND
C   PK IS PROPORTION OF LAND TYPES IN ILAND
C   SUMK, SUMI, SUMIK, ARE USED IN CALCULATING INDECES
C   PIJK IS PROPORTION OF 3-PIXEL PATTERNS IN LAND
C   IW IS FLAG FOR PRINTING OUT INTERMEDIATE CALCULATIONS
C   ID1 IS FIRST DIMENSION OF LAND
C   NUM IS NUMBER OF UNIQUE LAND TYPES
C  NUMPIX IS TOTAL NUMBER OF NON-ZERO PIXELS IN LAND
C  H1 = -SUM(PK*LN(PK))  I=1,NUM
C  D1 = LN(NUM) - H1
C  H3 =-SUM (PIJK*LN(PIJK)) I,J,K = 1,NUM
C  D3 = 2*NUM*LN(NUM) - H3
C
C
      REAL*8 PK(10), SUMI(10),SUMIK(10,10),PIJK(10,10,10),H1,D1,H3,D3
      REAL*8 SUMK(10)
      INTEGER*2  LAND(ID1,1)
      DO 9 I = 1,9
      PK(I) = 0.
      SUMI (I  )=0.
      SUMK (I  )=0.
      DO 9 J = 1,9
      SUMIK(I,J) = 0.
      DO 9 K = 1,9
    9 PIJK(I,J,K) = 0.
      TOT = 0.
C CALCULATE PROPORTION OF EACH LANDUSE TYPE
C COUNT THE NUMBER OF DIFFERENT LANDUSE TYPES
      NUM = 0
      DO 15 I = 1,IMAX
      DO 15 J = 1,JMAX
      INDEX = LAND(I,J)
      IF (INDEX .NE. 0) THEN
        TOT = TOT + 1
        SUMK(INDEX) = SUMK(INDEX) + 1
        ENDIF
   15 CONTINUE
      DO 16 I = 1,9
      IF (SUMK(I) .NE. 0) NUM = NUM + 1
   16 PK(I) = SUMK(I) / TOT
      NUMPIX = TOT
C
C CALCULATE NUMBER OF 'FROMS' OF EACH LANDUSE TYPE
C   (NORTH AND WEST VALUES)
C
      DO 20 I = 2,IMAX
      DO 20 J = 2,JMAX
      INDEX1 = LAND(I-1,J)
      INDEX2 = LAND(I,J-1)
      INDEX0 = LAND(I,J)
      IF (INDEX1 .NE. 0 .AND. INDEX2 .NE. 0 .AND. INDEX0 .NE. 0) THEN
        SUMI(INDEX1) =
     1   SUMI(INDEX1) + 1
        SUMIK(INDEX1,INDEX0) =
     1   SUMIK(INDEX1,INDEX0) + 1
        PIJK(INDEX1,INDEX2,INDEX0) =
     1   PIJK(INDEX1,INDEX2,INDEX0) + 1
        ENDIF
   20 CONTINUE
C
C CALCULATE CONDITIONAL PROBABILITY FROM NORTH AND WEST
C
      DO 40 I = 1,9
      DO 40 J = 1,9
      DO 40 K = 1,9
   40 IF (SUMI(I) .NE. 0.) PIJK(I,J,K) = PIJK(I,J,K) / SUMI(I)
      IF(IW .EQ. 0)CALL WRITEP(PK,SUMK,SUMI,SUMIK ,PIJK)
      H1 = 0.
C
C CALCULATE H1 AND D1
C
      DO 60 I = 1,9
   60 IF (PK(I) .NE. 0.) H1 = H1 + PK(I)*LOG(PK(I))
      H1 = - H1
      D1 = LOG(REAL(NUM)) - H1
C
C CALCULATE H3 AND D3
C
      H3 = 0.
      DO 80 I = 1,9
      DO 80 J = 1,9
      DO 80 K = 1,9
   80 IF (PIJK(I,J,K) .NE. 0.) H3 = H3 + PIJK(I,J,K)*LOG(PIJK(I,J,K))
      H3 = - H3
      D3 = 2*NUM*LOG(REAL(NUM)) - H3
      IF (IW .EQ. 0)WRITE (6,70) NUMPIX,NUM, H1, D1 ,H3, D3
   70 FORMAT (   '0NUMBER OF PIXELS,LANDTYPES, H1, D1, H3, D3 '
1    1 ,I10,I5, 4G18.8)
      RETURN
      END

      SUBROUTINE WRITEP(PK,SUMK,SUMI,SUMIK,PIJK)
C
C   WRITE OUT THE PROBABILITY OF LANDTYPES
C
      REAL*8 SUMI(10),SUMK(1),SUMIK(10,10), PIJK(10,10,10), PK(10)
      WRITE (6,5)
    5 FORMAT (' SUMI USED IN CALCULATING PIJK'        )
      DO 10 I = 1,9
       IF (SUMI(I) .NE. 0.) WRITE (6,20) I,SUMI (I)
  20    FORMAT (1H , I5,3G18.8)
  21    FORMAT (1H , I5,3G18.8)
  10  CONTINUE
      WRITE (6,4)
    4 FORMAT ('0LANDTYPE    FREQUENCY         PK')
      DO 50 I = 1,9
        IF (PK  (I) .NE. 0.) WRITE (6,21) I, SUMK(I),PK(I)
  50  CONTINUE
      WRITE (6,6)
    6 FORMAT (25H1PIJK                             )
      DO 30 I = 1,9
      DO 30 J = 1,9
      DO 30 K = 1,9
        IF (PIJK(I,J,K) .NE. 0.) WRITE(6,40) I,J,K,PIJK(I,J,K)
   40   FORMAT (1H , 3I5, 2G20.8)
   30 CONTINUE
      WRITE (6,7)
    7 FORMAT (25H1SUMIK                            )
      DO 60 I = 1,9
      DO 60 K = 1,9
        IF(SUMIK(I,K) .NE. 0.) WRITE(6,70) I,K,SUMIK(I,K)
   70   FORMAT (1H , 2I5, 2G20.8)
   60 CONTINUE
      RETURN
      END
      SUBROUTINE HARA(SITE,XIJ,IW,F)
C
C   CLACULATE SEVERAL STATISTICS ATTRIBUTED TO HARALICK
C
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION F(16)
      DIMENSION P(10,10),BIGP(10,10),XIJ(10,10)
      DIMENSION PXPY(10),PXMY(10),PX(10),PY(10)
      DIMENSION Q(10,10),WR(10),WI(10),EV(10,10),IV1(10),FV1(10)
      CHARACTER*20 SITE
      F1 = 0.
      F2 = 0.
      F3 = 0.
      F4 = 0.
      F5 = 0.
      F6 = 0.
      F7 = 0.
      F8 = 0.
      F9 = 0.
      F10= 0.
      F11= 0.
      F12= 0.
      F13= 0.
      F14= 0.
      F15= 0.
      F16= 0.
      AX = 0.
      AY = 0.
      SX = 0.
      SY = 0.
      AVE = 0.
      SUMBP = 0.
      DO 1 I=1,10
      PXPY(I) = 0.
      PXMY(I) = 0.
      PX(I) = 0.
      PY(I) = 0.
      DO 1 J = 1,10
C     XIJ(I,J) = 0.
      BIGP(I,J) = 0.
    1 P(I,J) = 0.
C  5  READ(20,10,END=40) NUM,SITE(NUM),I,J,XIJ(NUM,I,J)
C  10 FORMAT (I5,A20, 1X,2I1,2X,G15.0)
C     GO TO 5
   40 CONTINUE
C
C  XIJ HAS RELATIVE FREQUENCIES
C  BIGP HAS THE ADDITION OF THE OFF DIAGONAL ELEMENTS
C    AND TWICE THE DIAGONAL ELEMENTS TO CONFORM TO THE
C    MATIRX IN HARALICK 73,  TEXTURAL FEATURES FOR IMAGE
C    CLASSIFICATION
C
      DO 20 J=1,10
      DO 20 I = 1,10
        BIGP(I,J) = XIJ(I,J) + XIJ(J,I)
        SUMBP = SUMBP + BIGP(I,J)
   20   CONTINUE
C
C  CALCULATE LITTLE P(I,J)
C
      IF (IW .EQ. 0)WRITE(6,8)
    8 FORMAT ('1SITENAME,I,J,XIJ(I,J),BIGP(I,J),P(I,J)')
      DO 50 I=1,10
      DO 50 J=1,10
        P(I,J) = BIGP(I,J)/SUMBP
        IF (P(I,J) .NE. 0.) THEN
        IF (IW .EQ. 0)WRITE (6,6) SITE,I,J,XIJ(I,J),BIGP(I,J),P(I,J)
C       WRITE(30,61) SITE,I,J,P(I,J)
        ENDIF
   6    FORMAT (' ',A20,2I5,5X,3G15.5)
  61    FORMAT (A20,5X,2I1,5X,G18.8)
   50   CONTINUE
C
C  CALCULATE PX AND PY FOR EACH SITE
C
      TOT = 0
      DO 2950 I=1,10
      DO 2950 J=1,10
        PX(I) = PX(I) + P(I,J)
        PY(J) = PY(J) + P(I,J)
        AVE = AVE + P(I,J)
        IF (P(I,J) .NE. 0.) TOT=TOT+1
 2950 CONTINUE
        AVE = AVE/TOT
 2900 CONTINUE
      IF (IW .EQ. 0)WRITE(6,2930) AVE
 2930 FORMAT (' AVERAGE OF PIJ MATRIX',G15.5)
      IF (IW .EQ. 0)WRITE (6,2920) (I,PX(I),PY(I),I=1,10)
 2920 FORMAT (' PX,PY'/(I5,2G15.5))
C
C  CALCULATE MEAN AND STD DEV OF PX AND PY
C
        NX = 0
        NY = 0
        DO 2800 I=1,10
          AX = AX + PX(I)
          AY = AY + PY(I)
          IF (PX(I) .NE. 0.)NX = NX + 1
          IF (PY(I) .NE. 0.)NY = NY + 1
 2800     CONTINUE
        AX = AX/NX
        AY = AY/NY
        DO 2600 I=1,10
          IF(PX(I) .NE. 0.)SX = SX + (PX(I) - AX)**2
          IF(PY(I) .NE. 0.)SY = SY + (PY(I) - AY)**2
 2600     CONTINUE
        SX = SQRT(SX/(NX-1))
        SY = SQRT(SY/(NY-1))
 2700 CONTINUE
      IF (IW .EQ. 0)WRITE (6,2710)    AX,AY,SX,SY
 2710 FORMAT (' AX,AY,SX,SY'/  ' ',4G15.5)
C
C   CALCULATE P (X+Y) FOR EACH LANDUSE
C
      DO 3000 K=2,20
      DO 3000 I=1,10
      DO 3000 J=1,10
        IF (I+J .EQ. K) PXPY(K)=PXPY(K)+ P(I,J)
 3000   CONTINUE
      IF (IW .EQ. 0)WRITE (6,3010) (I,PXPY(I),I=2,20)
 3010 FORMAT(' PXPY'/(I5,G15.5))
C
C   CALCULATE P (X-Y) FOR EACH LANDUSE
C
      DO 3100 K=0,9
      DO 3100 I=1,10
      DO 3100 J=1,10
        IF (ABS(I-J) .EQ. K) PXMY(K)=PXMY(K)+ P(I,J)
 3100   CONTINUE
      IF (IW .EQ. 0)WRITE (6,3110) (I,PXMY(I),I=0,9)
 3110 FORMAT(' PXMY'/(I5,G15.5))
C
C  ANGULAR SECOND MOMENT
C
      DO 100 I=1,10
      DO 100 J=1,10
        F1 = F1 + P(I,J)**2
C       IF(P(I,J) .NE. 0.) WRITE (6,6) N,I,J,P(I,J),F1
  100   CONTINUE
C
C   CONTRAST
C
      DO 200 M=0,9
      DO 200 I=1,10
      DO 200 J=1,10
        IF (ABS(I-J) .EQ. M) F2=F2+ M*M*P(I,J)
  200   CONTINUE
C
C  CORRELATION
C
        DO 310 I=1,10
        DO 310 J=1,10
          F3 = F3 + I*J*P(I,J)
  310     CONTINUE
        IF (SX .NE. 0. .AND. SY .NE. 0.)THEN
          F3 =(F3 - AX*AY)/(SX*SY)
          ELSE
          F3 = 0.
          ENDIF
  300 CONTINUE
C
C  SUM OF SQUARES:VARIANCE
C
      DO 400 I=1,10
      DO 400 J=1,10
        F4 = F4 + (I-AVE)**2*P(I,J)
  400 CONTINUE
C
C  PRODUCT MOMENT:COVARIANCE
C
      DO 500 I=1,10
      DO 500 J=1,10
        F5 = F5 + (I-AVE)*(J-AVE)*P(I,J)
  500 CONTINUE
C
C  INVERSE DIFFERENCE MOMENT
C
      DO 600 I=1,10
      DO 600 J=1,10
        F6=F6+ P(I,J)/(1+(I-J)**2)
  600   CONTINUE
C
C   DIFFERENCE MOMENT
C
      DO 700 I=1,10
      DO 700 J=1,10
        F7 = F7 + (I-J)**2*P(I,J)
  700   CONTINUE
C
C   SUM AVERAGE
C
      DO 800 K=2,20
        F8 = F8 + K*PXPY(K)
  800   CONTINUE
C
C   SUM VARIANCE
C
      DO 900 K=2,20
        F9 = F9 + (K-F8)**2 * PXPY(K)
  900   CONTINUE
C
C   SUM ENTROPY
C
      DO 1000 K=2,20
        IF (PXPY(K) .NE. 0.)
     1  F10= F10 - PXPY(K)* LOG(PXPY(K))
 1000   CONTINUE
C
C   ENTROPY
C
      DO 1100 I=1,10
      DO 1100 J=1,10
        IF (P(I,J) .NE. 0.)
     1  F11= F11 - P(I,J) * LOG(P(I,J))
 1100   CONTINUE
C
C   DIFFERENCE VARIANCE
C
        APXMY = 0.
        NPXMY = 0
        DO 1210 K=0,9
          APXMY = APXMY + PXMY(K)
          IF (PXMY(K) .NE. 0) NPXMY = NPXMY + 1
 1210     CONTINUE
        APXMY = APXMY/NPXMY
        VPXMY = 0.
        DO 1220 K=0,9
 1220     VPXMY = VPXMY + (PXMY(K) - APXMY)**2
        F12 = VPXMY/(NPXMY-1)
      IF (IW .EQ. 0)WRITE (6,1230) NPXMY,APXMY,VPXMY
 1230 FORMAT (' NPXMY,APXMY,VPXMY',I5,2G15.5)
 1200   CONTINUE
C
C   DIFFERENCE ENTROPY
C
      DO 1300 K=0,9
        IF (PXMY(K) .NE. 0.)
     1  F13= F13 - PXMY(K)* LOG(PXMY(K))
 1300   CONTINUE
C
C  INFORMATION MEASURES OF CORRELATION
C
        HXY = F11
        HXY1=0.
        HXY2=0.
        HX = 0.
        HY = 0.
        DO 1410 I = 1,10
          IF(PX(I) .NE. 0.)HX = HX - PX(I)*LOG(PX(I))
          IF(PY(I) .NE. 0.)HY = HY - PY(I)*LOG(PY(I))
          DO 1410 J=1,10
            IF(PX(I) .EQ. 0. .OR. PY(J) .EQ. 0) GO TO 1410
            HXY1 = HXY1 - P(I,J)*LOG(PX(I)*PY(J))
            HXY2 = HXY2 - PX(I)*PY(J)*LOG(PX(I)*PY(J))
 1410     CONTINUE
        F14 = ABS(HXY - HXY1)/MAX(HX,HY)
        IF(1. - EXP(-2.*(HXY2 - HXY)) .GE. 0.)
     1    F15 = SQRT(1. - EXP(-2.*(HXY2 - HXY)))
      IF (IW .EQ. 0)WRITE (6,1420) HX,HY,HXY,HXY1,HXY2
 1420 FORMAT (' HX,HY,HXY,HXY1,HXY2',5G15.5)
 1400 CONTINUE
C
C  MAXIMAL CORRELATION COEFFICIENT
C
        DO 1610 I =1,10
        DO 1610 J =1,10
        Q(I,J) = 0.
        IF (PX(I) .EQ. 0. .OR. PY(J) .EQ. 0.) GO TO 1610
        DO 1610 K =1,10
        Q(I,J) = Q(I,J) + P(I,K)*P(J,K)/(PX(I)*PY(J))
 1610   CONTINUE
        IMAX = 0
        JMAX = 0
        DO 1620 I =1,10
        DO 1620 J=1,10
        IF (Q(I,J) .NE. 0.) IMAX = MAX(I,IMAX)
        IF (Q(I,J) .NE. 0.) JMAX = MAX(J,JMAX)
        IF (IW .EQ. 0)WRITE (6,1650) I,J,Q(I,J)
 1650 FORMAT (' Q',2I5,G15.5)
 1620   CONTINUE
        NMAX = MAX(IMAX,JMAX)
        CALL RG(10,NMAX,Q,WR,WI,0,EV,IV1,FV1,IERR)
        CALL SORTAR(WR,10)
        F16 = SQRT(WR(2))
        IF(IW .EQ. 0)WRITE(6,1630)NMAX,IERR,(I,WR(I),WI(I),I=1,NMAX)
 1630   FORMAT ('NMAX,IERR,WR,WI',/2I5/(I5,2G15.5))
 1600 CONTINUE
C
C
        IF (IW .EQ. 0)WRITE (6,2019)
 2019   FORMAT ('016 HARALICK INDECES')
        IF (IW .EQ. 0)WRITE(6 ,2020) SITE,F1,F2,F3,F4,F5,F6,
     1  F7,F8,F9,
     2  F10,F11,F12,F13,F14,F15,F16
        F(1 ) = F1
        F(2 ) = F2
        F(3 ) = F3
        F(4 ) = F4
        F(5 ) = F5
        F(6 ) = F6
        F(7 ) = F7
        F(8 ) = F8
        F(9 ) = F9
        F(10) = F10
        F(11) = F11
        F(12) = F12
        F(13) = F13
        F(14) = F14
        F(15) = F15
        F(16) = F16
C       WRITE(10,2010) SITE,F1,F2,F3,F4,F5,F6,
C    1  F7,F8,F9,
C    2  F10,F11,F12,F13,F14,F15,F16
 2010   FORMAT (A20,16G15.7)
 2020   FORMAT (' ',A20,5G15.7/(21X,5G15.7))
 2000   CONTINUE
      RETURN
      END
      SUBROUTINE SORTAR(X,N)
C
C  BUBBLE SORT -- USE ONLY FOR SMALL ARRAYS
C
      REAL*8 X(1)
    5 IFLAG = 0
      DO 10 I=1,N-1
      IF (X(I) .LT. X(I+1)) THEN
         Y = X(I)
         X(I) = X(I+1)
         X(I+1) = Y
         IFLAG = 1
         ENDIF
      IF (IFLAG .NE. 0) GO TO 5
   10 CONTINUE
      RETURN
      END
/*
//*
//*  PICK LANDSCAPE FROM ADIRONDA,LAKEGEN2,OR LAKEBLK
//*      BY COMMENTING DD STATEMENT
//GO.FT20F001 DD DSN=A.BJH36144.ADIRONDA,DISP=SHR
//* //GO.FT20F001 DD DSN=BJH.LAKEGEN2,DISP=SHR
//* //GO.FT20F001 DD DSN=BJH.LAKEBLK,DISP=SHR
//GO.FT40F001 DD DSN=A.BJH36144.WATER,DISP=SHR
//*
//*  THE FOLLOWING FLAT FILES ARE FOR INPUT TO SAS PROGRAM
//*
//GO.FT10F001 DD DSN=BJH.TEMIND2A,UNIT=DISK,
// DISP=(NEW,CATLG),SPACE=(TRK,(5,5),RLSE),
// DCB=(RECFM=FB,LRECL=400,BLKSIZE=2000)
//GO.FT30F001 DD DSN=BJH.TEMPAT2A,UNIT=DISK,
// DISP=(NEW,CATLG),SPACE=(TRK,(5,5),RLSE),
// DCB=(RECFM=FB,LRECL=30,BLKSIZE=3000)
//GO.FT50F001 DD DSN=BJH.TEMWAT2A,UNIT=DISK,
// DISP=(NEW,CATLG),SPACE=(TRK,(5,5),RLSE),
// DCB=(RECFM=FB,LRECL=80,BLKSIZE=4000)
//GO.FT70F001 DD DSN=BJH.WATRSH2A,UNIT=DISK,
// DISP=(NEW,CATLG),SPACE=(TRK,(5,5),RLSE),
// DCB=(RECFM=FB,LRECL=80,BLKSIZE=4000)
/*
