//BJHADSAS JOB (36144,I10),'B JACKSON BIN J',TIME=(5)
//* /*ROUTE XEQ WHENEVER
//* BJHADSAS JOB (36144,I2),'B JACKSON BIN J',TIME=(1)
// EXEC SAS,REGION=800K
//INDICES  DD DSN=BJH.TEMIND1R,DISP=SHR
//*
//*  INCLUDE THE DD CARDS FOR THE FLAT FILES
//*
//PATFREQ  DD DSN=BJH.TEMPAT1R,DISP=SHR
//MCWATER  DD DSN=BJH.TEMWAT1R,DISP=SHR
//WATERSH  DD DSN=BJH.WATRSH1R,DISP=SHR
//* DATASETS TEMIND1R ARE SCENARIO 1, RANDOM LANDSCAPE
//* DATASETS TEMIND2R ARE SCENARIO 2, RANDOM LANDSCAPE
//* DATASETS TEMIND1B ARE SCENARIO 1, BLOCKED LANDSCAPE
//* DATASETS TEMIND2B ARE SCENARIO 2, BLOCKED LANDSCAPE
//* DATASETS TEMIND1A ARE SCENARIO 1, ACTUAL(ADIRONDACK) LANDSCAPE
//* DATASETS TEMIND2A ARE SCENARIO 2, ACTUAL(ADIRONDACK) LANDSCAPE
//* DATASETS TEMIND2A ARE CREATED BY #LAKPATW1
//* INDICES  DD DSN=BJH.TEMPIND,DISP=SHR
//* PATFREQ  DD DSN=BJH.TEMPPAT,DISP=SHR
//* MCWATER  DD DSN=BJH.TEMPWAT,DISP=SHR
//* WATERSH  DD DSN=BJH.WATERSH,DISP=SHR
//* //INDICES  DD DSN=&&TEMPIND,DISP=SHR
//* //PATFREQ  DD DSN=&&TEMPPAT,DISP=SHR
//* //MCWATER  DD DSN=&&TEMPWAT,DISP=SHR
//* //WATERSH  DD DSN=&&TEMPWSH,DISP=SHR
//LAKES DD DSN=A.BJH36144.LAKES,DISP=OLD
//SYSIN DD *
OPTIONS DQUOTE;
*
  MEN.X10.BJH.LAKES(LAKPSAS1)
  THIS IS A SAS PROGRAM THAT READS IN DATA FROM FLAT
  FILES CREATED BY THE LAKES(LAKPATW1) PROGRAM
;
*
   FILL IN A VALUE FOR SCENE WHICH WILL BE PART OF THE
     PERMANENT DATA SET NAMES.  (2 LETTERS) EXAMPLE:
       B2 IS BLOCKED LANDSCAPE, SCENARIO 2
   FILL IN A VALUE FOR LABEL WHICH DESCRIBES THE LANDSCAPE
      EXAMPLE: BLOCKED IS THE BLOCKED LANDSCAPE
   SCENE AND LABEL ARE USED IN THE LABELS FOR THE PERMANENT
      DATASETS
;
%LET SCENE=R1;
%LET LABEL=RANDOM  ;
*;
  TITLE1 "SCENARIO &SCENE &LABEL";
*
   READ IN THE INDICES DATASET WHICH CONTAINS THE P-VALUES,
    DOMINANCE (D1),CONTAGION (D3), HARALICK STATISTICS H1-H16,
    ALL SORTS OF EDGE STATISTICS
;
  DATA INDICES BASE;
   INFILE INDICES;
   ATTRIB SITENAME LENGTH=$20;
     ATTRIB P1  LABEL="% URBAN";
     ATTRIB P2  LABEL="% AGRICULTURE";
     ATTRIB P3  LABEL="% RANGELAND";
     ATTRIB P41 LABEL="% DECIDIOUS FOREST";
     ATTRIB P42 LABEL="% CONIFEROUS FOREST";
     ATTRIB P43 LABEL='% MIXED FOREST';
     ATTRIB P4  LABEL='% FOREST';
     ATTRIB P5  LABEL="% WATER";
     ATTRIB P6  LABEL="% WETLAND";
     ATTRIB P7  LABEL="% BARREN";
     ATTRIB DEC_EDGE LABEL='DECID-OPEN EDGE';
     ATTRIB CON_EDGE LABEL='CONIF-OPEN EDGE';
     ATTRIB MIX_EDGE LABEL='MIXED-OPEM EDGE';
     ATTRIB DEC_AGR  LABEL='DECID-AGR EDGE';
     ATTRIB CON_AGR  LABEL='CONIF-AGR EDGE';
     ATTRIB MIX_AGR  LABEL='MIXED-AGR EDGE';
     ATTRIB DEC_WET  LABEL='DECID-WETLAND EDGE';
     ATTRIB CON_WET  LABEL='CONIF-WETLAND EDGE';
     ATTRIB MIX_WET  LABEL='MIXED-WETLAND EDGE';
     ATTRIB FORINTER LABEL='FOREST INTERIOR';
     ATTRIB NUM_USES LABEL='NUMBER OF LANDUSES';
     ATTRIB F1 LABEL='ANGULAR SECOND MOMENT';
     ATTRIB F2 LABEL='CONTRAST';
     ATTRIB F3 LABEL='CORRELATION';
     ATTRIB F4  LABEL='SUM OF SQUARES VARIANCE';
     ATTRIB F5  LABEL='PRODUCT MOMENT COVARIANCE';
     ATTRIB F6  LABEL='INVERSE DIFFERENCE MOMENT';
     ATTRIB F7  LABEL='DIFFERENCE MOMENT';
     ATTRIB F8  LABEL='SUM AVERAGE';
     ATTRIB F9  LABEL='SUM VARIANCE';
     ATTRIB F10 LABEL='SUM ENTROPY';
     ATTRIB F11 LABEL='ENTROPY';
     ATTRIB F12 LABEL='DIFFERENCE VARIANCE';
     ATTRIB F13 LABEL='DIFFERENCE ENTROPY';
     ATTRIB F14 LABEL='INFORMATION MEASURE OF CORRELATION 1';
     ATTRIB F15 LABEL='INFORMATION MEASURE OF CORRELATION 2';
     ATTRIB F16 LABEL='MAXIMAL CORRELATION COEFFICIENT';
     ATTRIB H1  LABEL='H1';
     ATTRIB D1  LABEL='D1';
     ATTRIB H3  LABEL='H3';
     ATTRIB D3  LABEL='D3';
     ATTRIB PINIT  LABEL='PROB OF EPICENTER';
     ATTRIB NUMPAT LABEL='NUMBER OF PATCHES';
     ATTRIB CHGPIX LABEL='NUMBER OF CHANGED PIXELS';
     ATTRIB NUMPIX LABEL='TOTAL NUMBER OF PIXELS';
     ATTRIB ITER LABEL ='ITERATION COUNT';
     ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
     ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
   INPUT SITENAME $20. ITER NUM_USES NUMPIX NUMPAT CHGPIX FORINTER
      H1 D1 H3 D3 F1-F16
      DEC_EDGE CON_EDGE MIX_EDGE
      DEC_AGR  CON_AGR  MIX_AGR
      DEC_WET  CON_WET  MIX_WET
      P1-P3  P41 P42 P43 P5-P7 PINIT
;
     P4 = P41 + P42 + P43;
     P1=P1*100; P2=P2*100; P3=P3*100; P4=P4*100; P5=P5*100;
     P41=P41*100; P42=P42*100; P43=P43*100;
     P6=P6*100; P7=P7*100;
     LANDSCAP ="&LABEL";
     SCENARIO= "&SCENE";
*   THE FIRST RECORD IS THE BASE CASE, THE OTHER ARE THE MONTE CARLO
     (INFESTED MATRIX);
     IF _N_ = 1 THEN OUTPUT BASE; ELSE OUTPUT INDICES;
* PRINT BASE CASE AND MONTECARLO VALUES;
  TITLE2 "BASE CASE FOR ADIRONDACKS ";
  PROC PRINT DATA=BASE;
RUN;
  TITLE2 "RANDOM INDICES FOR ADIRONDACKS ";
  PROC PRINT DATA=INDICES;
RUN;
TITLE2 'PROC CONTENTS FOR INDICES ';
 PROC CONTENTS DATA=INDICES;
RUN;
TITLE2 'UNIVARIATE ';
  PROC UNIVARIATE DATA=INDICES NORMAL PLOT;
*
  READ IN THE PATFREQ DATASET WHICH HAS THE STATISTICS
    ABOUT PATCH SIZES
;
DATA PATFREQ;
  INFILE PATFREQ;
  INPUT PINIT ITERATE PATSIZE FREQ;
   ATTRIB PINIT  LABEL='PROB OF EPICENTER';
   ATTRIB ITERATE LABEL ='ITERATION';
   ATTRIB PATSIZE LABEL ='PATCH SIZE';
   ATTRIB FREQ LABEL ='FREQUENCY';
     ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
     ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
     LANDSCAP = "&LABEL";
     SCENARIO = "&SCENE";
*
  CALCULATE AND PRINTOUT FREQUENCY OF PATCH SIZES
;
TITLE2 "FREQUENCY OF PATCH SIZES FOR ALL ITERATIONS";
PROC FREQ DATA=PATFREQ;
  TABLES PINIT*PATSIZE / LIST OUT=PATFREQ;
  WEIGHT FREQ;
RUN;
TITLE2 "PROC CONTENTS ";
PROC CONTENTS DATA=PATFREQ;
*    */;
* PROC PRINT DATA=LAKES.LAKEDATA (OBS=5 );
* TITLE2 'LAKES.LAKEDATA SIMPLE LAKES DATASET';
*PROC CONTENTS DATA=LAKES.LAKEDATA;
*
  READ IN WATERSHED DATA AND CALCULATE PERCENTAGE OF
    EACH LANDUSE OF INTEREST IN EACH WATERSHED
;
  DATA WATERSH;
    INFILE WATERSH;
    ATTRIB POND_NO LABEL='POND NUMBER' LENGTH=$7;
    ATTRIB LANDUSE LABEL='LAND TYPE';
    ATTRIB LAND1 LABEL='LEVEL 1 LAND TYPE';
     ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
     ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
    INPUT UTM_NV UTM_EV POND_NO $  LANDUSE;
    LAND1 = FLOOR(LANDUSE/10);
     IF LANDUSE=41 THEN LAND1 = 41;
     IF LANDUSE=42 THEN LAND1 = 42;
     IF LANDUSE=43 THEN LAND1 = 43;
     LANDSCAP = "&LABEL";
     SCENARIO = "&SCENE";
*PROC PRINT DATA=WATERSH (OBS=10);
PROC SUMMARY DATA=WATERSH;
  CLASS POND_NO LAND1;
  VAR LAND1;
  OUTPUT OUT=SUMOUT N=N;
 *PROC PRINT DATA=SUMOUT  (OBS=10);
 * TITLE2 'SOME PRINTOUT FROM PROC SUMMARY';
DATA TOTPOND (KEEP=NP POND_NO) TABLE(KEEP=NLAND1 POND_NO LAND1)
     OTHPOND (KEEP= _TYPE_ N LAND1);
  SET SUMOUT;
  ATTRIB NLAND1 LABEL='PIXELS FOR LANDTYPE';
  ATTRIB NP LABEL='PIXELS IN WATERSHED';
  ATTRIB N  LABEL='NUMBER OF PIXELS';
  IF _TYPE_=2 THEN DO;
   NP = N;
   OUTPUT TOTPOND;
   END;
  IF _TYPE_=0 OR _TYPE_ = 1 THEN DO;
   OUTPUT OTHPOND;
   END;
  IF _TYPE_=3 THEN DO;
    NLAND1 = N;
    OUTPUT TABLE;
    END;
PROC SORT DATA=TABLE;
  BY POND_NO LAND1;
PROC SORT DATA=TOTPOND;
  BY POND_NO ;
DATA NEWTAB;
  MERGE TABLE TOTPOND;
  BY POND_NO;
  ATTRIB P_LAND1 LABEL='PCT OF LANDTYPE';
  IF LAND1 NE .;
  P_LAND1 = NLAND1/NP*100.;
  KEEP POND_NO LAND1 NLAND1 NP P_LAND1;
PROC PRINT LABEL DATA=OTHPOND;
  TITLE2 'WATERSHED CHARACTERISTICS';
PROC PRINT LABEL DATA=NEWTAB;
  TITLE2 'WATERSHED CHARACTERISTICS';
*
  READ IN MONTECARLO (INFESTED MATRIX) WATERSHED STATISTICS
;
DATA MCWATER;
  INFILE MCWATER;
    ATTRIB ITER LABEL='ITERATION COUNT';
    ATTRIB POND_NO LABEL='POND NUMBER' LENGTH=$7;
    ATTRIB HRDWD2_P LABEL='HARDWOOD AREA        %TERR. WTRSHD';
    ATTRIB CONFR2_P LABEL='CONIFER AREA         %TERR. WTRSHD';
    ATTRIB NONFR2_P LABEL='NONFORESTED AREA     %TERR. WTRSHD';
    ATTRIB LNONFR2P LABEL='LOG(NONFOREST AREA+1)%TERR. WTRSHD';
    ATTRIB PINIT  LABEL='PROB OF EPICENTER';
     ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
     ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
     LANDSCAP = "&LABEL";
     SCENARIO = "&SCENE";
  INPUT PINIT ITER POND_NO $ HRDWD2_P CONFR2_P NONFR2_P;
  LNONFR2P = LOG10(NONFR2_P+1);
PROC PRINT DATA=MCWATER (OBS=67);
 TITLE2 'SOME MONTE CARLO WATERSHED DATA';
 PROC SORT DATA=MCWATER;
   BY POND_NO ITER;
*
  GET WATERSHED VARIABLES FROM LAKE DATABASE
;
DATA
  LAKENAME (KEEP=POND_NO LAKE_NM LAKE_A WTRSHD_A
                 CONFR2_P HRDWD2_P NONFR2_P)
  LAKEDATA (KEEP=POND_NO
        LDRAINA   LAKE_DEV  LAKE_E  ASPECT_S
        RUNOFF    HYDTYP1   HYDTYP2  HYDTYP3
        H_CONC
        RELIEF_R  STONEY_P  HYDRO_A  HYDRO_B  STEEPM_P  STEEPV_P
        ROCK12_P
        CECS_L_P  OM_H_P    PHC_VL_P   CEC
        WTLND_PP  VACID_PP  NACID_PP  LWTLNDPW  LNACIDPW
        DISTRB_P  LBVRINDX  CABN78_R)
  LAKEORIG (KEEP=ITER POND_NO CONFR2_P HRDWD2_P LNONFR2P NONFR2_P)
;
   SET LAKES.LAKEDATA;
      ATTRIB LDRAINA LABEL='LOG10(DRAINAGE AREA)  HA';
      ATTRIB LWTLNDPW LABEL='LOG10(TOT WETLAND AREA+5) %TERR WATSH';
      ATTRIB LNACIDPW LABEL='LOG10(NONACID WETLAND+1) %TERR WATSH';
      ATTRIB LBVRINDX LABEL='LOG10(INL+INLL+OUT+OUTL)/LAKE_A+1)';
      ATTRIB LNONFR2P LABEL='LOG(NONFOREST AREA+1)%TERR. WTRSHD';
      ATTRIB ITER LABEL='ITERATION';
    LDRAINA = LOG10(DRAIN_A);
    LWTLNDPW = LOG10(WTLND_PW+5);
    LNACIDPW = LOG10(NACID_PW+1);
    LBVRINDX  = LOG10(BVRINDEX+1);
    LNONFR2P  = LOG10(NONFR2_P+1);
    ITER = -1;
    * OMIT LAKE PLACID;
    IF POND_NO = '020254' THEN DELETE;
PROC PRINT DATA=LAKENAME LABEL;
  TITLE2 'ORIGINAL WATERSHED DATA';
PROC SORT DATA=LAKEDATA;
   BY POND_NO;
DATA MCWAT;
  SET LAKEORIG MCWATER;
*PROC PRINT DATA=MCWAT (OBS=5);
  TITLE2 'ORIGINAL DATA, BASE CASE , MONTECARLO';
  PROC SORT DATA=MCWAT;
    BY POND_NO;
*
  MERGE ORIGINAL LAKE WATERSHED VARIABLES WITH THE MONTE CARLO
   WATERSHED VARIABLES
;
DATA NEWWAT;
  MERGE LAKEDATA MCWAT;
  BY POND_NO;
PROC PRINT DATA=NEWWAT (OBS=50);
  TITLE2
'SAMPLE(50 OBS) LAKEDATA MERGED ORIG DATA,BASECASE, AND MONTE CARLO';
*
  READ IN THE COEFFICIENTS FOR THE PH MODEL EQUATION
;
DATA COEFFS;
  ARRAY C(31) C1-C31;
  INPUT C1-C31;
CARDS;
  -.025  -.20  -.0016  -.0023
   .02    -.55   -.30   -.17
   -71.09
   .016  .0062  -.03  -.0092  -.0071  -.011
  -.006
  -.0029  -.027  .0049  .036
  -.013    .0037  .39
  -.0051  -.0035  .0058  .96  -.42
  -.0011  -.55  -.018
;
PROC PRINT DATA=COEFFS;
  TITLE2 'COEFFICIENTS FOR WATERSHED MODEL';
*
  MERGE THE COEFFICIENTS WITH THE WATERSHED VARIABLES
   AND CALCULATE PH ACCORDING TO THE MODEL
;
DATA MODEL;
  IF _N_=1 THEN SET COEFFS;
  SET NEWWAT;
  ARRAY V(31)
        LDRAINA    LAKE_DEV   LAKE_E   ASPECT_S
        RUNOFF     HYDTYP1    HYDTYP2   HYDTYP3
        H_CONC
        RELIEF_R   STONEY_P   HYDRO_A   HYDRO_B  STEEPM_P   STEEPV_P
        ROCK12_P
        CECS_L_P   OM_H_P     PHC_VL_P   CEC
        CONFR2_P   HRDWD2_P   LNONFR2P
        WTLND_PP   VACID_PP   NACID_PP  LWTLNDPW  LNACIDPW
        DISTRB_P   LBVRINDX   CABN78_R;
  ARRAY C(31) C1-C31;
  PH = 11.54;
  DO I = 1 TO 31;
    PH = PH + V(I) * C(I);
    END;
*
  SPLIT THE DATASET INTO ORIGINAL, BASECASE, AND MONTECARLO
;
DATA PHORIG (KEEP= POND_NO PH_ORIG)
     PHBASE (KEEP= POND_NO PINIT PH_BASE)
     PHRAN  (KEEP=ITER POND_NO PINIT PH)
     ;
  SET MODEL;
    ATTRIB PH_ORIG LABEL='PH ORIG';
    ATTRIB PH_BASE LABEL='PH BASE';
  IF ITER =-1 THEN DO;
         PH_ORIG=PH;
         OUTPUT PHORIG;
         END;
  IF ITER = 0 THEN DO;
         PH_BASE = PH;
         OUTPUT PHBASE;
         END;
  IF ITER GT 0 THEN DO;
         OUTPUT PHRAN;
         END;
 DATA X;
   MERGE PHORIG PHBASE;
   BY POND_NO;
   ATTRIB PH_DIFF LABEL = 'PHORIG - PHBASE';
   PH_DIFF = PH_ORIG - PH_BASE;
 PROC PRINT LABEL DATA=X;
  TITLE2 'ORIGINAL DATA AND BASE CASE PH VALUES';
  PROC SORT DATA=PHRAN;
     BY POND_NO ITER;
*
  FIND STATISTICS ON THE MONTECARLO PH VALUES
;
 PROC MEANS DATA=PHRAN NOPRINT;
  BY POND_NO PINIT ;
  VAR PH ;
  OUTPUT OUT=PHAVE MEAN=PH_AVE STD=PH_STD
       N = PH_N  MIN=PH_MIN  MAX =PH_MAX;
*
  DATASET THAT COMPARES AVERAGE PH FOR MONTE CARLO WITH
    PH FOR BASE CASE AND ORIGINAL
;
  DATA COMPARE;
    MERGE PHAVE PHBASE PHORIG;
    ATTRIB PH_AVE LABEL='AVG PH';
    ATTRIB DIFF_PH LABEL='AVGPH - PHBASE';
    ATTRIB DIFF_OR LABEL='AVGPH - PHORIG';
    ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
    ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
    BY POND_NO;
    DIFF_PH = PH_AVE - PH_BASE;
    DIFF_OR = PH_AVE - PH_ORIG;
    LANDSCAP = "&LABEL";
    SCENARIO = "&SCENE";
 PROC PRINT LABEL DATA=COMPARE;
   TITLE2 'COMPARISON OF BASE CASE PH WITH MONTE CARLO';
*
  PREPARE DATASET THAT WILL SHOW THE PH SHIFTS FROM
    BASE CASE TO MONTE CARLO PH'S
;
 DATA SHIFT;
   MERGE PHRAN PHBASE ;
   BY POND_NO;
PROC PRINT DATA=SHIFT (OBS=200);
   TITLE2 'ALL PH VALUES';
 DATA SHIFT1 SHIFT2;
   SET SHIFT;
   IF PH-PH_BASE GT .2 THEN OUTPUT SHIFT1;
   IF PH_BASE <= 5.5 AND PH > 5.5 THEN OUTPUT SHIFT2;
*
  PRODUCE A TABLE THAT SHOWS HOW MANY PONDS HAD PH SHIFT
     OF GREATER THAN .2 FROM THE BASE CASE PH
;
PROC FREQ DATA=SHIFT1;
   TABLES ITER /OUT=OUT1 NOPRINT;
DATA OUT1;
  SET OUT1;
  ATTRIB COUNT LABEL='LAKES WITH PH SHIFT>.2';
    ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
    ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
    LANDSCAP = "&LABEL";
    SCENARIO = "&SCENE";
  DROP PERCENT;
PROC PRINT LABEL DATA=OUT1;
   TITLE2 'NUMBER OF LAKES WITH PH SHIFT > .2 FROM BASE CASE';
PROC UNIVARIATE DATA=OUT1 NORMAL PLOT;
  VAR COUNT;
*
  PRODUCE A TABLE THAT SHOWS HOW MANY PONDS HAD A SHIFT OF
    PH FROM LESS THAN 5.5 TO MORE THAN 5.5 FROM THE BASE
    PH TO THE MONTE CARLO PH
;
PROC FREQ DATA=SHIFT2;
   TABLES ITER/OUT=OUT2 NOPRINT;
DATA OUT2;
  SET OUT2;
    ATTRIB COUNT LABEL='LAKES WITH PH > 5.5';
    ATTRIB LANDSCAP LABEL='LANDSCAPE' LENGTH=$20;
    ATTRIB SCENARIO LABEL='SCENARIO' LENGTH=$4;
    LANDSCAP = "&LABEL";
    SCENARIO = "&SCENE";
  DROP PERCENT;
PROC PRINT LABEL DATA=OUT2;
   TITLE2 'NUMBER OF LAKES WITH PH > 5.5 AND BASE PH <=5.5';
PROC UNIVARIATE DATA=OUT2 NORMAL PLOT;
  VAR COUNT;
*
  SAVE ALL DATA OF INTEREST IN PERMANENT DATASETS
;
 DATA LAKES.COMPAR&SCENE (LABEL="COMPARE &SCENE &LABEL");
    SET COMPARE;
 DATA LAKES.ALLPH&SCENE  (LABEL="PH VALUES &SCENE &LABEL");
    SET SHIFT;
 DATA LAKES.PHGT2S&SCENE (LABEL="SCENARIO &SCENE &LABEL");
   SET OUT1;
 DATA LAKES.PHG55S&SCENE (LABEL="SCENARIO &SCENE &LABEL");
   SET OUT2;
 DATA LAKES.INDEXR&SCENE
           (LABEL="RANDOM INDICES &SCENE &LABEL");
   SET INDICES;
 DATA LAKES.INDEXB&SCENE
            (LABEL="BASE INDICES &SCENE &LABEL");
   SET BASE;
 DATA LAKES.PATFR&SCENE
                (LABEL="PATCHSIZE DIST &SCENE &LABEL");
   SET PATFREQ;
/*
